diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 3ccb32e60..352fa0f17 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -22,7 +22,6 @@ import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.Textures;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.item.Item;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index 60084e433..7c7554931 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -21,7 +21,7 @@ import java.util.HashMap;
 import java.util.List;
 
 public class ViewerCategoryBlock extends ModelViewerCategory {
-    public HashMap<Block, BlockEntry> entryHashMap = new HashMap<>();
+    public HashMap<Block<?>, BlockEntry> entryHashMap = new HashMap<>();
     public TextCycleElement<Integer> blockIdTextField;
     public TextCycleElement<Integer> blockMetaTextField;
     public ViewerCategoryBlock(ScreenModelViewer modelViewer) {
@@ -29,7 +29,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         createEntries();
     }
     public void createEntries(){
-        for (Block block : Blocks.blocksList){
+        for (Block<?> block : Blocks.blocksList){
             if (block == null) continue;
             entryHashMap.put(block, new BlockEntryBasic(block));
         }
@@ -46,7 +46,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
 
     @Override
     public String getCurrentDisplayInfo(I18n translator) {
-        Block displayBlock = Blocks.getBlock(DisplayChunk.displayBlockId);
+        Block<?> displayBlock = Blocks.getBlock(DisplayChunk.displayBlockId);
         String name = "None";
         if (displayBlock != null){
             name = I18n.getInstance().translateNameKey(displayBlock.getKey());
@@ -170,7 +170,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         mc.currentWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
     }
     public void setDisplayBlock(int id, int meta){
-        Block displayBlock = Blocks.blocksList[DisplayChunk.displayBlockId];
+        Block<?> displayBlock = Blocks.blocksList[DisplayChunk.displayBlockId];
         BlockEntry entry = entryHashMap.get(Blocks.getBlock(DisplayChunk.displayBlockId));
         int _id = DisplayChunk.displayBlockId;
         int _meta = DisplayChunk.displayBlockMeta;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
index cce7e9a8c..588d6022b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
@@ -9,8 +9,8 @@ import net.minecraft.core.world.World;
 import java.util.List;
 
 public abstract class BlockEntry {
-    public Block block;
-    public BlockEntry(Block block){
+    public Block<?> block;
+    public BlockEntry(Block<?> block){
         this.block = block;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryBasic.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryBasic.java
index e55c7746b..131aba683 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryBasic.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryBasic.java
@@ -9,7 +9,7 @@ import net.minecraft.core.world.World;
 import java.util.List;
 
 public class BlockEntryBasic extends BlockEntry{
-    public BlockEntryBasic(Block block) {
+    public BlockEntryBasic(Block<?> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
index 90c02ceb8..ebadac288 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
@@ -5,7 +5,6 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.util.helper.MathHelper;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntrySign.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntrySign.java
index a5f5394d1..671f79483 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntrySign.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntrySign.java
@@ -13,7 +13,7 @@ import java.util.ArrayList;
 import java.util.List;
 
 public class BlockEntrySign extends BlockEntry{
-    public BlockEntrySign(Block block) {
+    public BlockEntrySign(Block<?> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
index 435785984..ef4036727 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
@@ -5,7 +5,6 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
-import net.minecraft.core.block.Block;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityFallingBlock;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
index 6ba13b55c..6c5accb5b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
@@ -7,7 +7,6 @@ import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
index 44390d55f..7184241e0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
@@ -5,7 +5,6 @@ import net.minecraft.client.entity.particle.ParticleItemBreaking;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index b047b70bb..bf0635aa5 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -19,10 +19,10 @@ import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFurnaceBlastFurnace;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.block.entity.TileEntityTrommel;
@@ -870,7 +870,7 @@ public class PacketHandlerClient extends PacketHandler
                 break;
             }
             case PacketContainerOpen.TYPE_BLAST_FURNACE: {
-                TileEntityFurnaceBlastFurnace tileEntityFurnaceBlast = new TileEntityFurnaceBlastFurnace();
+                TileEntityFurnaceBlast tileEntityFurnaceBlast = new TileEntityFurnaceBlast();
                 mc.thePlayer.displayFurnaceScreen(tileEntityFurnaceBlast);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 52ea1add8..3441840c7 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -51,7 +51,7 @@ public abstract class PlayerController {
 			return;
 		}
 
-		Block mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block<?> mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {
 			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
 			
@@ -77,7 +77,7 @@ public abstract class PlayerController {
 			return;
 		}
 		
-		Block mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block<?> mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(mineBlock != null) {	
 			syncCurrentPlayItem();
 			
@@ -150,19 +150,19 @@ public abstract class PlayerController {
 		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		setMineBlock(null, null, null);
 		World world = mc.currentWorld;
-		Block block = Blocks.getBlock(world.getBlockId(x, y, z));
+		Block<?> block = Blocks.getBlock(world.getBlockId(x, y, z));
 		if(block == null) return false;
 		
 		Item heldItem = null;
 		ItemStack heldItemStack = player.getCurrentEquippedItem();
 		if(heldItemStack != null) {
-			if(!heldItemStack.beforeDestroyBlock(world, block.id, x, y, z, side, player)) {
+			if(!heldItemStack.beforeDestroyBlock(world, block.id(), x, y, z, side, player)) {
 				return false;
 			}
 			heldItem = heldItemStack.getItem();
 		}
 		
-		world.playBlockEvent(EVENT_BLOCK_BREAK, x, y, z, block.id);
+		world.playBlockEvent(EVENT_BLOCK_BREAK, x, y, z, block.id());
 		int meta = world.getBlockMetadata(x, y, z);
 		boolean removed = world.setBlockWithNotify(x, y, z, 0);
 		if(removed) {
@@ -185,7 +185,7 @@ public abstract class PlayerController {
 		if (!mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return;
 		mc.currentWorld.onBlockHit(mc.thePlayer, x, y, z, side);
 		
-		Block block = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
+		Block<?> block = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
 		if(block != null) {
 			block.onBlockLeftClicked(mc.currentWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
 		}
@@ -313,7 +313,7 @@ public abstract class PlayerController {
 		player.craftingInventory = player.inventorySlots;
 	}
 	
-	public void playDigSound(Block block, int x, int y, int z) {
+	public void playDigSound(Block<?> block, int x, int y, int z) {
 		if(soundDelay <= 0) {
 			mc.currentWorld.playBlockSoundEffect(null, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.DIG);
 			soundDelay = 3;
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 7f2bab88e..ea84e2740 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 64af7299f..8044d2c89 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -51,7 +51,7 @@ public class ItemRenderer
 
     public int getItemColorFromMetadata(Item item, int metadata) {
         if (item instanceof ItemBlock) {
-            Block block = ((ItemBlock)item).getBlock();
+            Block<?> block = ((ItemBlock<?>)item).getBlock();
             return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
         }
         return 0xFFFFFF;
@@ -139,8 +139,8 @@ public class ItemRenderer
 			
 			int id = mc.currentWorld.getBlockId(blockX, blockY, blockZ);
             int meta = mc.currentWorld.getBlockMetadata(blockX, blockY, blockZ);
-            Block block = Blocks.blocksList[id];
-            BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
+            Block<?> block = Blocks.blocksList[id];
+            BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
 			if(mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
 				renderInsideOfBlock(partialTicks, model.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
 			} else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 8ebdb9258..69eadfcc9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -153,7 +153,7 @@ public final class ParticleEngine {
      * @param data The metadata value of the destroyed block.
      */
     public void destroy(int x, int y, int z, int id, int data) {
-        Block block = Blocks.blocksList[id];
+        Block<?> block = Blocks.blocksList[id];
         if (block == null) return;
         int amount = 4;
         if (block == Blocks.FIRE) {
@@ -184,7 +184,7 @@ public final class ParticleEngine {
         if (id == 0) {
             return;
         }
-        Block block = Blocks.blocksList[id];
+        Block<?> block = Blocks.blocksList[id];
         AABB bounds = block.getBounds();
         float r = 0.1F;
         double xp = x + rand.nextDouble() * (bounds.maxX - bounds.minX - (r * 2.0F)) + r + bounds.minX;
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index 339d989ba..188f03851 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -26,10 +26,10 @@ final public class RenderBlockCache {
     private int offsetY = Integer.MAX_VALUE;
     private int offsetZ = Integer.MAX_VALUE;
     
-    private Block block;
+    private Block<?> block;
     private WorldSource access;
 
-    public void setupCache(Block block, WorldSource access, int x, int y, int z){
+    public void setupCache(Block<?> block, WorldSource access, int x, int y, int z){
         if(x != offsetX || y != offsetY || z != offsetZ || this.block != block || this.access != access) {
             this.block = block;
             this.access = access;
@@ -46,14 +46,14 @@ final public class RenderBlockCache {
 		float brightness = block.getBlockBrightness(access, x, y, z);
 
 		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-			int lightEmission = Blocks.lightEmission[block.id];
+			int lightEmission = block.emission;
 			if(lightEmission >= 15) {
 				return 1.0f;
 			}
 			if(!mc.isAmbientOcclusionEnabled()) {
 				return 1.0f;
 			}
-			Block block = access.getBlock(x, y, z);
+            Block<?> block = access.getBlock(x, y, z);
 			if(block == null) {
 				return 1.0f;
 			}
@@ -90,7 +90,7 @@ final public class RenderBlockCache {
     public int getLightmapCoord(int relX, int relY, int relZ) {
     	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
     	if(!lightmapCoordCached[index]) {
-    		int lightEmission = Blocks.lightEmission[block.id];
+    		int lightEmission = block.emission;
     		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission);
     		lightmapCoordCached[index] = true;
     	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 642e161c2..a38c8bea9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -56,7 +56,7 @@ public class RenderBlocks
     {
         if (mc.fullbright) return 1.0f;
         int id = blockAccess.getBlockId(x, y, z);
-        Block block = blockAccess.getBlock(x, y, z);
+        Block<?> block = blockAccess.getBlock(x, y, z);
         if (block != null)
         {
 
@@ -66,7 +66,7 @@ public class RenderBlocks
         return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
     }
 
-	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<Block> blockModel, Block block, WorldSource world, int x, int y, int z) {
+	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<?> blockModel, Block<?> block, WorldSource world, int x, int y, int z) {
 		final boolean lightmap = LightmapHelper.isLightmapEnabled();
 		
 		float sideBottom = 1.0f;
@@ -148,7 +148,7 @@ public class RenderBlocks
 		tessellator.draw();
 	}
 
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z)
+    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z)
     {
         int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(blockAccess, x, y, z);
         float r = (float)(color >> 16 & 0xff) / 255F;
@@ -161,7 +161,7 @@ public class RenderBlocks
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
+    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
         this.enableAO = true;
         int meta = blockAccess.getBlockMetadata(x, y, z);
         cache.setupCache(blockModel.block, blockAccess, x, y, z);
@@ -172,7 +172,7 @@ public class RenderBlocks
         this.enableAO = false;
         return somethingRendered;
     }
-    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
+    public final boolean renderSide(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
         boolean useColor;
         switch (side){
             case BOTTOM:
@@ -226,7 +226,7 @@ public class RenderBlocks
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public final boolean renderSide(Tessellator tessellator, BlockModel<Block> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
+    public final boolean renderSide(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP
@@ -264,11 +264,11 @@ public class RenderBlocks
         }
         return rendered;
     }
-    public final void setupLighting(Block block, int x, int y, int z, float r, float g, float b, int side, int meta,
+    public final void setupLighting(Block<?> block, int x, int y, int z, float r, float g, float b, int side, int meta,
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP){
-    	boolean ao = mc.isAmbientOcclusionEnabled() && Blocks.lightEmission[block.id] == 0;
+    	boolean ao = mc.isAmbientOcclusionEnabled() && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
     	if(LightmapHelper.isLightmapEnabled()) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index b54465e5e..84e6d65ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1300,7 +1300,7 @@ public class RenderGlobal
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
             GL11.glPushMatrix();
             int k = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
-            Block block = k <= 0 ? null : Blocks.blocksList[k];
+            Block<?> block = k <= 0 ? null : Blocks.blocksList[k];
             GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(-3F, -3F);
             GL11.glEnable(32823 /*GL_POLYGON_OFFSET_FILL*/);
@@ -1734,7 +1734,7 @@ public class RenderGlobal
 
             case EVENT_BLOCK_BREAK: // Block break effect
                 if(data > 0) {
-                    Block block = Blocks.blocksList[data];
+                    Block<?> block = Blocks.blocksList[data];
 
                     worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
                 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index b69e8554a..7908c72c5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -36,7 +36,6 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -807,7 +806,7 @@ public class WorldRenderer
             {
                 continue;
             }
-            if(Blocks.blocksList[i2].blockMaterial == Material.lava)
+            if(Blocks.blocksList[i2].getMaterial() == Material.lava)
             {
                 mc.particleEngine.add(new ParticleSmoke(world, (float)randX + f1, (double)((float)y + 0.1F) - Blocks.blocksList[i2].getBounds().minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
                 continue;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 5a9c764dc..40deaa376 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -6,7 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 
 public final class BlockColorDispatcher
-    extends Dispatcher<Block, BlockColor>
+    extends Dispatcher<Block<?>, BlockColor>
 {
     private static final BlockColorDispatcher instance = new BlockColorDispatcher();
     private static final BlockColor defaultColor = new BlockColorDefault();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 8ba0c6fb7..e21074ca7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -4,18 +4,19 @@ import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class BlockModel<T extends Block>
+public abstract class BlockModel<T extends BlockLogic>
 {
     public static RenderBlocks renderBlocks;
-    public final T block;
+    public final Block<T> block;
     protected boolean hasOverbright = false;
-    public BlockModel(Block block){
-        this.block = (T) block;
+    public BlockModel(Block<T> block){
+        this.block = block;
     }
     public abstract boolean render(Tessellator tessellator, int x, int y, int z);
     public boolean renderNoCulling(Tessellator tessellator, int x, int y, int z) {
@@ -88,23 +89,23 @@ public abstract class BlockModel<T extends Block>
     }
 
     public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z){
-        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, bounds, x, y, z);
+        return renderBlocks.renderStandardBlock(tessellator, this, bounds, x, y, z);
     }
     public final boolean renderStandardBlock(Tessellator tessellator, AABB bounds, int x, int y, int z, float r, float g, float b){
-        return renderBlocks.renderStandardBlock(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b);
+        return renderBlocks.renderStandardBlock(tessellator, this, bounds, x, y, z, r, g, b);
     }
     public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, 1, 1, 1, side, meta);
+        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, 1, 1, 1, side, meta);
     }
     public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b, side, meta);
+        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, r, g, b, side, meta);
     }
     public final boolean renderSide(Tessellator tessellator,  AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
                                     int dirX, int dirY, int dirZ, float depth,
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP
     ){
-        return renderBlocks.renderSide(tessellator, (BlockModel<Block>) this, bounds, x, y, z, r, g, b, side, meta,
+        return renderBlocks.renderSide(tessellator, this, bounds, x, y, z, r, g, b, side, meta,
                 dirX, dirY, dirZ, depth,
                 topX, topY, topZ, topP, botP,
                 lefX, lefY, lefZ, lefP, rigP);
